<?php
/**
 * Widget Popular Posts
 *
 * @package Simple Days
 */


class simple_days_popular_post_widget extends WP_Widget {

	
	function __construct() {
		parent::__construct(
			'simple_days_popular_post_widget', // Base ID
			esc_html__( '[Simple Days] Popular Posts', 'simple-days' ), // Name
			array( 'description' => esc_html__( 'Support popular posts for Widget', 'simple-days' ), ) // Args
		);
	}
	public function widget( $args, $instance ) {
	  echo $args['before_widget'];
	  //echo esc_html(apply_filters( 'widget_title', $instance['popular_post_title'] ));
    $popular_post_title = !empty( $instance['popular_post_title'] ) ? $instance['popular_post_title'] : '';
    $post_not_in = !empty( $instance['post_not_in'] ) ? $instance['post_not_in'] : '';
    $category_not_in = !empty( $instance['category_not_in'] ) ? $instance['category_not_in'] : '';
    $include_page  = !empty( $instance['include_page'] ) ? $instance['include_page'] : '';
    $number_post = !empty( $instance['number_post'] ) ? absint( $instance['number_post'] ) : 5 ;
    $archive_rank  = ! empty( $instance['archive_rank'] ) ? $instance['archive_rank'] : '';
    $display_style  = ! empty( $instance['display_style'] ) ? $instance['display_style'] : '1';

    $count_key = '_simple_days_popular_posts_count';
    $period_key = '_simple_days_popular_posts_period';
    $period = get_theme_mod( 'simple_days_popular_post_period' , 'all');
switch ($period){
case 'all':
  $rank_name = esc_html__('Popular Posts', 'simple-days');
  $period_value = 'all';
  break;
case 'monthly':
  $rank_name = esc_html__('Monthly Popular Posts', 'simple-days');
  $period_value = date('Y').date('n');
  break;
case 'weekly':
  $rank_name = esc_html__('Weekly Popular Posts', 'simple-days');
  $period_value = date('Y').date('W');
  break;
case 'daily':
  $rank_name = esc_html__('Daily Popular Posts', 'simple-days');
  $period_value = date('Y').date('n').date('j');
  break;
default:
}
    $rank_name = $popular_post_title != '' ? $popular_post_title : $rank_name;
    $include_page  = $include_page == '1' ? array( 'post', 'page') : 'post';
    $post_not_in = explode(',', $post_not_in);
    $category_not_in = explode(',', $category_not_in);
    $archive_pala = array();
    $archive_name = '';
    if($archive_rank == '1'){
      if(is_single()){
        $category = get_the_category();
        $archive_pala = array('category__in' => $category[0]->term_id);
        $archive_name = $category[0]->cat_name.' ';
      }
      if(is_category()){
        $archive_pala = array('category__in' => get_query_var('cat'));
        $archive_name = single_cat_title('', false).' ';
      }
      if(is_tag()){
        $archive_pala = array('tag__in' => get_query_var('tag_id'));
        $archive_name = single_tag_title('', false).' ';
      }
      if(is_author()){
        $archive_pala = array('author__in' => get_query_var('author'));
        global $wp_query;
        $curauth = $wp_query->get_queried_object();
        $archive_name = $curauth->display_name.' ';
      }
      /*if(is_year()){
        $archive_pala = array('date_query' => array(array('year'=> get_query_var('year')),);
      }
      if(is_month());
      if(is_day());*/
    }


    $popular_args = array(
      'post_type' => $include_page,
      'meta_key' => $count_key,
      'post__not_in' => $post_not_in,
      'category__not_in' => $category_not_in,
      'posts_per_page' => $number_post,
      'orderby' => 'meta_value_num',
      'meta_query' => array(
          array(
             'key' => $period_key,
             'value' => $period_value,
             'compare' => '=')
      )
    );
    $popular_args = array_merge($popular_args,$archive_pala);
    $posts = new WP_Query( $popular_args );
//var_dump($posts);
    if ( $posts->have_posts() ) {

      echo '<div class="pp_ranking">';
      echo '<h3 class="widget_title">'.esc_html($archive_name).esc_html($rank_name).'</h3>';
      echo '<ul class="pp_ranking_ul">';
  // The loop
      $i=1;
      if( $display_style=='1'){
        while ( $posts->have_posts() ) {
          $posts->the_post();
         //var_dump($posts);
         echo '<li class="pp_ranking_box_list pp_ranking_box_list_border"><div class="pp_ranking_box_list_thum_title"><div><span class="pp_ranking_box_list_rank">'.esc_html($i).'</span></div><div><a href="' . esc_url(get_permalink( $posts->ID )) . '" class="">'.esc_html(mb_strimwidth(get_the_title(), 0, 48, "...", 'UTF-8')).'</a></div></div></li>';
         $i++;
        }
      }else if( $display_style=='2'){
        while ( $posts->have_posts() ) {
          $posts->the_post();
         //var_dump($posts);
         echo '<li class="pp_ranking_box_list_thum"><div><div class="pp_ranking_box_list_rank_box"><span class="pp_ranking_box_list_rank">'.esc_html($i).'</span></div><div class="pp_ranking_box_list_title_box"><a href="' . esc_url(get_permalink( $posts->ID )) . '" class="non_hover pp_ranking_box_list_title">'.esc_html(mb_strimwidth(get_the_title(), 0, 48, "...", 'UTF-8')).'</a></div></div><a href="' . esc_url(get_permalink( $posts->ID )) . '"><div class="fit_box_img_wrap pp_ranking_box_list_thum_box">';
         if(!has_post_thumbnail($posts->ID)) {
         preg_match_all("/<img[^>]+src=[\"'](s?https?:\/\/[\-_\.!~\*'()a-z0-9;\/\?:@&=\+\$,%#]+\.(jpg|jpeg|png|gif))[\"'][^>]+>/i", get_the_content(), $matches);
           if(isset($matches [1] [0])){
             echo '<'.( (is_amp() )?'amp-img layout="responsive"':'img').' src="'. esc_url($matches [1] [0]) .'" width="640" height="480" alt="'.esc_html(get_the_title()).'" />';
           }else{
             echo '<'.( (is_amp()) ?'amp-img layout="responsive"':'img').' src="'. esc_url(get_template_directory_uri()) .'/assets/images/no_image.png" width="640" height="480" alt="No image available" />';
           }
         }else{
           //the_post_thumbnail(array(640, 480));
           $thumurl = wp_get_attachment_image_src( get_post_thumbnail_id($posts->ID) , 'medium' );
           echo '<'.( (is_amp() )?'amp-img layout="responsive"':'img').' src="'.esc_url($thumurl[0]).'" width="'.esc_attr($thumurl[1]).'" height="'.esc_attr($thumurl[2]).'" alt="'.esc_html(get_the_title()).'" title="'.esc_html(get_the_title()).'" />';
         }
         echo '</div></a></li>';
         $i++;
        }

      }else if( $display_style=='3'){

        while ( $posts->have_posts() ) {
          $posts->the_post();
         //var_dump($posts);
         echo '<li class="pp_ranking_box_list pp_ranking_box_list_border"><div class="pp_ranking_box_list_thum_title"><div><span class="pp_ranking_box_list_rank">'.esc_html($i).'</span></div><div><a href="' . esc_url(get_permalink( $posts->ID )) . '" class="">'.esc_html(mb_strimwidth(get_the_title(), 0, 48, "...", 'UTF-8')).'</a></div></div><div class="fit_box_img_wrap pp_ranking_box_list_thum_img">';
         if(!has_post_thumbnail($posts->ID)) {
         preg_match_all("/<img[^>]+src=[\"'](s?https?:\/\/[\-_\.!~\*'()a-z0-9;\/\?:@&=\+\$,%#]+\.(jpg|jpeg|png|gif))[\"'][^>]+>/i", get_the_content(), $matches);
           if(isset($matches [1] [0])){
             echo '<'.( (is_amp() )?'amp-img layout="responsive"':'img').' src="'. esc_url($matches [1] [0]) .'" width="640" height="480" alt="'.esc_html(get_the_title()).'" />';
           }else{
             echo '<'.( (is_amp()) ?'amp-img layout="responsive"':'img').' src="'. esc_url(get_template_directory_uri()) .'/assets/images/blank.png" width="640" height="480" alt="No image available" />';
           }
         }else{
           //the_post_thumbnail(array(640, 480));
           $thumurl = wp_get_attachment_image_src( get_post_thumbnail_id($posts->ID) , array(45,45) );
           echo '<'.( (is_amp() )?'amp-img layout="responsive"':'img').' src="'.esc_url($thumurl[0]).'" width="'.esc_attr($thumurl[1]).'" height="'.esc_attr($thumurl[2]).'" alt="'.esc_html(get_the_title()).'" title="'.esc_html(get_the_title()).'" />';
         }
         echo '</div></li>';
         $i++;
        }
      }
      // Reset post data
      wp_reset_postdata();
      echo '</ul></div>';

    }

    echo $args['after_widget'];
	}
	public function form( $instance ) {
    $popular_post_title = ! empty( $instance['popular_post_title'] ) ? $instance['popular_post_title'] : '';
    $post_not_in = ! empty( $instance['post_not_in'] ) ? $instance['post_not_in'] : '';
    $category_not_in = !empty( $instance['category_not_in'] ) ? $instance['category_not_in'] : '';
    $number_post   = ! empty( $instance['number_post'] ) ? $instance['number_post'] : 5 ;
    $display_style  = ! empty( $instance['display_style'] ) ? $instance['display_style'] : '1';
    $include_page  = ! empty( $instance['include_page'] ) ? $instance['include_page'] : '';
    $archive_rank  = ! empty( $instance['archive_rank'] ) ? $instance['archive_rank'] : '';
    ?>
    <p>
      <label for="<?php echo esc_attr( $this->get_field_id( 'title' ) ); ?>"><?php esc_html_e( 'Title', 'simple-days' ); ?></label>
      <input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'popular_post_title' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'popular_post_title' ) ); ?>" type="text" value="<?php echo esc_attr( $popular_post_title ); ?>">
    </p>
    <p>
      <label for="<?php echo esc_attr( $this->get_field_id( 'number_post' ) ); ?>"><?php esc_html_e( 'Display priorities', 'simple-days' ); ?></label>
      <input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'number_post' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'number_post' ) ); ?>" type="number" step="1" min="1" max="20" value="<?php echo esc_attr( $number_post ); ?>" />
    </p>
    <p>
      <label for="<?php echo esc_attr( $this->get_field_id( 'display_style' ) ); ?>">
        <?php esc_html_e( 'Display style', 'simple-days' ); ?></label><br />
      <label for="<?php echo esc_attr( $this->get_field_id( 'display_style' ) ); ?>_1">
        <input id="<?php echo esc_attr( $this->get_field_id( 'display_style' ) ); ?>_1" name="<?php echo esc_attr( $this->get_field_name( 'display_style' ) ); ?>" type="radio" value="1" <?php checked( '1', $display_style ); ?>/>
      <?php esc_html_e( 'List', 'simple-days' ); ?></label>
      <label for="<?php echo esc_attr( $this->get_field_id( 'display_style' ) ); ?>_2">
        <input id="<?php echo esc_attr( $this->get_field_id( 'display_style' ) ); ?>_2" name="<?php echo esc_attr( $this->get_field_name( 'display_style' ) ); ?>" type="radio" value="2" <?php checked( '2', $display_style ); ?>/>
      <?php esc_html_e( 'Thumbnail', 'simple-days' ); ?></label>
      <label for="<?php echo esc_attr( $this->get_field_id( 'display_style' ) ); ?>_3">
        <input id="<?php echo esc_attr( $this->get_field_id( 'display_style' ) ); ?>_3" name="<?php echo esc_attr( $this->get_field_name( 'display_style' ) ); ?>" type="radio" value="3" <?php checked( '3', $display_style ); ?>/>
      <?php esc_html_e( 'List &#43; Thumbnail', 'simple-days' ); ?></label>
    </p>
    <p>
      <label for="<?php echo esc_attr( $this->get_field_id( 'category_not_in' ) ); ?>"><?php esc_html_e( ' Disappear when you type category id.', 'simple-days' ); ?><br /><?php esc_html_e( ' Multiple id must be seperated by a comma.', 'simple-days' ); ?></label>
      <input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'category_not_in' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'category_not_in' ) ); ?>" type="text" value="<?php echo esc_attr( $category_not_in ); ?>">
    </p>
    <p>
      <label for="<?php echo esc_attr( $this->get_field_id( 'post_not_in' ) ); ?>"><?php esc_html_e( ' Disappear when you type post id.', 'simple-days' ); ?><br /><?php esc_html_e( ' Multiple id must be seperated by a comma.', 'simple-days' ); ?></label>
      <input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'post_not_in' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'post_not_in' ) ); ?>" type="text" value="<?php echo esc_attr( $post_not_in ); ?>">
    </p>
    <p>
      <input id="<?php echo esc_attr( $this->get_field_id( 'include_page' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'include_page' ) ); ?>" type="checkbox" value="1" <?php checked( '1', $include_page ); ?>/>
      <label for="<?php echo esc_attr( $this->get_field_id( 'include_page' ) ); ?>"><?php esc_html_e( 'include page', 'simple-days' ); ?></label>
    </p>
    <p>
      <input id="<?php echo esc_attr( $this->get_field_id( 'archive_rank' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'archive_rank' ) ); ?>" type="checkbox" value="1" <?php checked( '1', $archive_rank ); ?>/>
      <label for="<?php echo esc_attr( $this->get_field_id( 'archive_rank' ) ); ?>"><?php esc_html_e( 'Enable archive ranking in archive', 'simple-days' ); ?></label>
    </p>
    <?php
	}
	public function update( $new_instance, $old_instance ) {
    $instance = array();
    $instance['popular_post_title'] = ( ! empty( $new_instance['popular_post_title'] ) ) ? sanitize_text_field( $new_instance['popular_post_title'] ) : '';
    $instance['archive_rank'] = ! empty( $new_instance['archive_rank'] ) ? absint( $new_instance['archive_rank'] ) : '';
    $instance['include_page'] = ! empty( $new_instance['include_page'] ) ? absint( $new_instance['include_page'] ) : '';
    $instance['display_style'] = ! empty( $new_instance['display_style'] ) ? absint( $new_instance['display_style'] ) : '1';
    $instance['number_post'] = ! empty( $new_instance['number_post'] ) ? absint( $new_instance['number_post'] ) : 5 ;
    $instance['post_not_in'] = ! empty( $new_instance['post_not_in'] ) ? sanitize_text_field( $new_instance['post_not_in'] ) : '';
    $instance['category_not_in'] = ! empty( $new_instance['category_not_in'] ) ? sanitize_text_field( $new_instance['category_not_in'] ) : '';
    return $instance;
	}

} // class simple_days_profile_widget
