<?php
/**
 * Widget TOC
 *
 * @package Simple Days
 */


class simple_days_toc_widget extends WP_Widget {

	
	function __construct() {
		parent::__construct(
			'simple_days_toc_widget', // Base ID
			esc_html__( '[Simple Days] TOC', 'simple-days' ), // Name
			array( 'description' => esc_html__( 'Support table of contents for Widget', 'simple-days' ), ) // Args
		);
	}
	public function widget( $args, $instance ) {
		$simple_days_toc_html = '';
		$simple_days_toc_html = get_query_var('simple_days_toc_html');
		if ($simple_days_toc_html != ''){
		  //echo $args['before_widget'];
		  echo esc_html(apply_filters( 'widget_title', $instance['toc_title'] ));
          echo apply_filters( 'widget_text',$simple_days_toc_html );
		  //echo $args['after_widget'];
		}
	}
	public function form( $instance ) {
		$toc_title = ! empty( $instance['toc_title'] ) ? $instance['toc_title'] : '';
		?>
		<p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'title' ) ); ?>"><?php esc_attr_e( 'Title', 'simple-days' ); ?></label>
		<input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'toc_title' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'toc_title' ) ); ?>" type="text" value="<?php echo esc_attr( $toc_title ); ?>">
		</p>
		<?php
	}
	public function update( $new_instance, $old_instance ) {
		$instance = array();
		$instance['toc_title'] = ( ! empty( $new_instance['toc_title'] ) ) ? sanitize_text_field( $new_instance['toc_title'] ) : '';
		return $instance;
	}

} // class simple_days_toc_widget
